add notification scripts

This commit is contained in:
Robert Habermann 2020-01-05 15:42:47 +00:00
parent da84ee0ad9
commit 145ccf24cc
2 changed files with 300 additions and 0 deletions
home.admin

@ -0,0 +1,150 @@
#!/usr/bin/env python
# -*- coding: utf-8 -*-
import argparse
import os
import subprocess
from email.message import EmailMessage
try:
import smime
except ImportError:
raise ImportError("Please install missing package: python3 -m pip install smime")
SSMTP_BIN = "/usr/sbin/ssmtp"
def main():
parser = argparse.ArgumentParser(description="Send a notification")
parser.add_argument("-V", "--version", action="version",
help="print version", version="0.1")
parser.add_argument("-d", "--debug", action="store_true",
help="print debug output")
subparsers = parser.add_subparsers(dest='subparser')
# ext
parser_ext = subparsers.add_parser("ext", help="Notify by external command")
parser_ext.add_argument("cmd", type=str,
help="Path to external command")
parser_ext.add_argument("message", type=str,
help="Message to send")
# e-Mail
parser_mail = subparsers.add_parser("mail", help="Notify by e-Mail")
parser_mail.add_argument("recipient", type=str,
help="E-Mail address of recipient")
parser_mail.add_argument("message", type=str,
help="Message to send")
parser_mail.add_argument("-s", "--subject", type=str, default="RB Notification",
help="Subject for message")
parser_mail.add_argument("-c", "--cert", type=str, default="pub.pem",
help="Path to public x509 certificate of recipient")
parser_mail.add_argument("-e", "--encrypt", action="store_true",
help="S/MIME encrypt body")
parser_mail.add_argument("--from-name", type=str, default="From-Name",
help="Sender name")
parser_mail.add_argument("--from-address", type=str, default="from-address@example.com",
help="Sender e-Mail address")
# slack
parser_slack = subparsers.add_parser("slack", help="Notify by Slack")
parser_slack.add_argument("message", type=str,
help="Message to send")
# parse args and run selected subparser
kwargs = vars(parser.parse_args())
try:
globals()[kwargs.pop('subparser')](**kwargs)
except KeyError:
parser.print_help()
def ext(cmd=None, message=None, debug=False):
if debug:
print("calling: {}".format(cmd))
print("with msg: {}".format(message))
if not os.path.exists(cmd):
raise Exception("File not found: {}".format(cmd))
try:
subprocess.run([cmd, message], stderr=subprocess.STDOUT)
except subprocess.CalledProcessError as err:
print("Running shell command \"{}\" caused "
"error: {} (RC: {}".format(err.cmd, err.output, err.returncode))
raise Exception(err)
# e-Mail
def mail(recipient=None, message=None, subject=None, cert=None, encrypt=False,
from_name=None, from_address=None, debug=False):
if debug:
print("send mail")
print("msg: {}".format(message))
print("to: {}".format(recipient))
print("subject: {}".format(subject))
print("cert: {}".format(cert))
print("encrypt: {}".format(encrypt))
if encrypt:
if not os.path.exists(cert):
raise Exception("File not found: {}".format(cert))
msg_content = [
"To: {}".format(recipient),
'From: "{} <{}>'.format(from_name, from_address),
"Subject: {}".format(subject),
"",
"{}".format(message)
]
with open(cert, 'rb') as pem:
msg = smime.encrypt('\n'.join(msg_content), pem.read())
msg_to_send = msg.encode()
else:
msg = EmailMessage()
msg['Subject'] = "{}".format(subject)
msg['From'] = '"{} <{}>'.format(from_name, from_address),
msg['To'] = recipient
msg.set_payload(message)
msg_to_send = msg.as_bytes()
# send message via e-Mail
if not os.path.exists(SSMTP_BIN):
raise Exception("File not found: {}".format(SSMTP_BIN))
try:
cmd = [SSMTP_BIN, recipient]
subprocess.run(cmd, input=msg_to_send, stderr=subprocess.STDOUT)
except subprocess.CalledProcessError as err:
print("Running shell command \"{}\" caused "
"error: {} (RC: {}".format(err.cmd, err.output, err.returncode))
raise Exception(err)
def slack(message=None, debug=False):
if debug:
print("send slack")
print("msg: {}".format(message))
raise NotImplementedError()
if __name__ == "__main__":
main()

@ -0,0 +1,150 @@
#!/bin/bash
if [ $# -eq 0 ]; then
echo "small script enabling/disabling and sending notification messages"
echo "network.notify.sh [on|off] - OR"
echo "network.notify.sh send \"Message to be send via configured method\""
exit 1
fi
# load config values
source /home/admin/raspiblitz.info 2>/dev/null
source /mnt/hdd/raspiblitz.conf 2>/dev/null
if [ ${#network} -eq 0 ]; then
echo "FAIL - was not able to load config data / network"
exit 1
fi
# make sure main "notify" setting is present (add with default if not)
if ! grep -Eq "^notify=.*" /mnt/hdd/raspiblitz.conf; then
echo "notify=off" | sudo tee -a /mnt/hdd/raspiblitz.conf >/dev/null
fi
# check all other settings and add if missing
if ! grep -Eq "^notifyMethod=.*" /mnt/hdd/raspiblitz.conf; then
echo "notifyMethod=mail" | sudo tee -a /mnt/hdd/raspiblitz.conf >/dev/null
fi
# Mail
if ! grep -Eq "^notifyMailTo=.*" /mnt/hdd/raspiblitz.conf; then
echo "notifyMailTo=mail@example.com" | sudo tee -a /mnt/hdd/raspiblitz.conf >/dev/null
fi
if ! grep -Eq "^notifyMailServer=.*" /mnt/hdd/raspiblitz.conf; then
echo "notifyMailServer=mail@example.com" | sudo tee -a /mnt/hdd/raspiblitz.conf >/dev/null
fi
if ! grep -Eq "^notifyMailUser=.*" /mnt/hdd/raspiblitz.conf; then
echo "notifyMailUser=username" | sudo tee -a /mnt/hdd/raspiblitz.conf >/dev/null
fi
if ! grep -Eq "^notifyMailPass=.*" /mnt/hdd/raspiblitz.conf; then
echo "notifyMailPass=password" | sudo tee -a /mnt/hdd/raspiblitz.conf >/dev/null
fi
if ! grep -Eq "^notifyMailEncrypt=.*" /mnt/hdd/raspiblitz.conf; then
echo "notifyMailEncrypt=off" | sudo tee -a /mnt/hdd/raspiblitz.conf >/dev/null
fi
if ! grep -Eq "^notifyMailToCert=.*" /mnt/hdd/raspiblitz.conf; then
echo "notifyMailToCert=/mnt/hdd/notify_mail_cert.pem" | sudo tee -a /mnt/hdd/raspiblitz.conf >/dev/null
fi
# Ext
if ! grep -Eq "^notifyExtCmd=.*" /mnt/hdd/raspiblitz.conf; then
echo "notifyExtCmd=/usr/bin/printf" | sudo tee -a /mnt/hdd/raspiblitz.conf >/dev/null
fi
# reload settings
source /mnt/hdd/raspiblitz.conf 2>/dev/null
###################
# switch on
###################
if [ "$1" = "1" ] || [ "$1" = "on" ]; then
echo "switching the NOTIFY ON"
# install sstmp if not already present
/usr/bin/which ssmtp &>/dev/null
[ $? -eq 0 ] || sudo apt-get install -y ssmtp
# install python lib for smime into virtual env
/home/admin/python3-env-lnd/bin/python -m pip install smime
# write ssmtp config
cat << EOF | sudo tee /etc/ssmtp/ssmtp.conf >/dev/null
#
# Config file for sSMTP sendmail
#
# The person who gets all mail for userids < 1000
# Make this empty to disable rewriting.
root=${notifyMailTo}
# hostname of this system
hostname=${hostname}
# relay/smarthost server settings
mailhub=${notifyMailServer}
AuthUser=${notifyMailUser}
AuthPass=${notifyMailPass}
UseSTARTTLS=YES
EOF
# edit raspi blitz config
echo "editing /mnt/hdd/raspiblitz.conf"
sudo sed -i "s/^notify=.*/notify=on/g" /mnt/hdd/raspiblitz.conf
exit 0
fi
###################
# switch off
###################
if [ "$1" = "0" ] || [ "$1" = "off" ]; then
echo "switching the NOTIFY OFF"
# edit raspi blitz config
echo "editing /mnt/hdd/raspiblitz.conf"
sudo sed -i "s/^notify=.*/notify=off/g" /mnt/hdd/raspiblitz.conf
exit 0
fi
###################
# send the message
###################
if [ "$1" = "send" ]; then
# check if "notify" is enabled - if not exit
if ! grep -Eq "^notify=on" /mnt/hdd/raspiblitz.conf; then
echo "Notifications are NOT enabled in /mnt/hdd/raspiblitz.conf"
exit 1
fi
/usr/bin/which ssmtp &>/dev/null
if ! [ $? -eq 0 ]; then
echo "please run \"on\" first"
exit 1
fi
# now parse settings from config and use to send the message
if [ "${notifyMethod}" = "ext" ]; then
/home/admin/python3-env-lnd/bin/python3 /home/admin/XXsendNotification.py ext ${notifyExtCmd} "$2"
elif [ "${notifyMethod}" = "mail" ]; then
if [ "${notifyMailEncrypt}" = "on" ]; then
/home/admin/python3-env-lnd/bin/python3 /home/admin/XXsendNotification.py mail --cert rhab.pem --encrypt ${notifyMailTo} "$2"
else
/home/admin/python3-env-lnd/bin/python3 /home/admin/XXsendNotification.py mail ${notifyMailTo} "$2"
fi
elif [ "${notifyMethod}" = "slack" ]; then
/home/admin/python3-env-lnd/bin/python3 /home/admin/XXsendNotification.py slack -h "$2"
else
echo "unknown notification method - check /mnt/hdd/raspiblitz.con"
fi
exit 0
fi
echo "FAIL - Unknown Paramter $1"
exit 1